<?php
/**
 * appRain v 0.1.x
 *
 * LICENSE
 *
 * This source file is subject to the MIT license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/mit-license.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@apprain.com so we can send you a copy immediately.
 *
 * @copyright  Copyright (c) 2010 appRain, Team. (http://www.apprain.com)
 * @license    http://www.opensource.org/licenses/mit-license.php MIT license
 *
 * HELP
 *
 * Official Website
 * http://www.apprain.com/
 *
 * Download Link
 * http://www.apprain.com/download
 *
 * Documents Link
 * http ://www.apprain.com/docs
 */

class Development_Helper_appGallery extends appRain_Base_Objects
{

	public function initLayout()
	{

		return 'default';
	}

	public function initAddons()
	{
		return Array(App::Helper('Config')->siteInfo('galleryopt_current'));
	}

	public function renderXMLResources()
	{
		echo
		'<?xml version="1.0" encoding="utf-8"?>
		<gallery>
			<message>XML data is not defined for this gallery.</message>
		</gallery>';
	}
}