<?php
class Development_Helper_Gallery_UvumiGallery extends Development_Helper_appGallery
{
	public function renderHTML()
	{
		$id = $this->getCategoryId();
		$pictures = App::InformationSet('picture')->findAll('1 ORDER BY ID DESC',Array(Array("category"=>"%{$id}%","cnd"=>"LIKE")));
		if(!empty($pictures['data']))
		{
			$html = '<div id="gallery">';
			foreach($pictures['data'] as $picture)
			{
					$html .=	App::Helper('Html')->linkTag(App::Helper("Config")->baseUrl("/uploads/filemanager/{$picture['image']}"),
									App::Helper('Html')->imgTag(App::Helper("Config")->baseUrl("/uploads/filemanager/{$picture['imagethumb']}")),
									array("alt"=>$picture['title'])
								);
			}
			$html .= '</div>';

			return $html;
		}
	}

}