<?php
/**
 * appRain v 0.1.x
 *
 * LICENSE
 *
 * This source file is subject to the MIT license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/mit-license.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@apprain.com so we can send you a copy immediately.
 *
 * @copyright  Copyright (c) 2010 appRain, Team. (http://www.apprain.com)
 * @license    http://www.opensource.org/licenses/mit-license.php MIT license
 *
 * HELP
 *
 * Official Website
 * http://www.apprain.com/
 *
 * Download Link
 * http://www.apprain.com/download
 *
 * Documents Link
 * http ://www.apprain.com/docs
 */

class Development_Helper_Pgateway_Common extends appRain_Base_Objects
{
    public $methods = Array('paypal','authorizenet');
    private $selectedindex = 0;
    const STATUS_ACTIVE = 'Active';
    const STATUS_INACTIVE = 'Inactive';

	public function __construct()
	{

	}

	public function renderPaymentMethods()
    {
        if(empty($this->methods)) return null;

        $html = "";
        foreach($this->methods as $key => $method)
        {
           if(
                App::Helper('Config')->siteInfo("{$method}_status") == self::STATUS_ACTIVE
             )
             {
                $html .=
                        "<div id=\"payment_method_{$method}_wrapper\">
                            <input type=\"radio\" id=\"payment_method_{$method}\" class=\"payment_method\" name=\"data[Payment][method]\" value=\"{$method}\" " . (($key==$this->selectedindex)? "checked=\"checked\"" : "") . " />" . App::Helper('Config')->siteInfo("{$method}_title") . "
                            <div id=\"payment_method_{$method}_add\" class=\"payment_method_add\">" . App::Helper("Pgateway_{$method}")->htmlToRender($method) . "</div>
                        </div>";
             }
        }
        return $html;
    }
}